import { Component, OnInit } from '@angular/core';
import { AgentsService } from '../../services/agent.service';
import { ActivatedRoute, Router } from '@angular/router';
import { Agent } from '../../interfaces/agent.interface';

@Component({
  selector: 'app-agent-add',
  templateUrl: './agent-add.component.html',
  styleUrls: ['./agent-add.component.css']
})
export class AgentAddComponent implements OnInit {

  public agent!: Agent;

  constructor(private _supervisorService: AgentsService, private _activatedRoute: ActivatedRoute, private _router: Router) {}

  ngOnInit(): void {
    this._activatedRoute.params.subscribe(param => {
      if (param['id']) {
        const id: number = param['id'];
        const agent = this._supervisorService.getAgentById(id);
        agent? this.agent = agent : this._router.navigate(['/supervisors']);
      } else {
        this.agent = this.getEmptyAgent();
      }
    })
  }

  getEmptyAgent(): Agent {
    return {
      id: 0,
      name: '',
      lastname: '',
      detail: '',
      email: '',
      password: ''
    };
  }
}
