import { Component, OnInit } from '@angular/core';
import { Agent } from '../../interfaces/agent.interface';
import { TableModel } from 'src/app/shared/interfaces/table-model.interface';
import { AgentsService } from '../../services/agent.service';
import { ResultDelete } from 'src/app/shared/interfaces/result-delete.interface';

@Component({
  selector: 'app-agents',
  templateUrl: './agents.component.html',
  styleUrls: ['./agents.component.css']
})
export class AgentsComponent implements OnInit {

  public tableData: Agent[] = [];

  public tableModel: TableModel[] = [
    {
      name: 'id',
      title: '#'
    },
    {
      name: 'name',
      title: "Nombres"
    },
    {
      name: 'lastname',
      title: "Apellidos"
    },
    {
      name: 'detail',
      title: "Detalles"
    }
  ];

  constructor(private _supervisorService: AgentsService) {}

  ngOnInit(): void {
    this.getAgents();
  }

  getAgents(): void {
    this.tableData = this._supervisorService.agents;
  }

  onDeleteAgent(result: ResultDelete): void {
    if (!result.result) return;
    this._supervisorService.deleteAgent(result.id);
    this.getAgents();
  }
}
