import { Injectable } from '@angular/core';
import { HttpClient } from '@angular/common/http';
import { Observable } from 'rxjs';
import { Agent } from '../interfaces/agent.interface';

@Injectable({providedIn: 'root'})
export class AgentsService {
  constructor(private httpClient: HttpClient) { }

  private _agents: Agent[] = [
    {
      id: 1,
      name: 'John',
      lastname: 'Doe',
      detail: 'Detail',
      email: 'jodoe@gmail.com',
      password: ''
    },
    {
      id: 2,
      name: 'Jane',
      lastname: 'Doe',
      detail: 'Detail',
      email: 'jdoe@gmail.com',
      password: ''
    },
    {
      id: 3,
      name: 'John',
      lastname: 'Smith',
      detail: 'Detail',
      email: 'jsmith@gmail.com',
      password: ''
    },
    {
      id: 4,
      name: 'Jane',
      lastname: 'Smith',
      detail: 'Detail',
      email: 'jasmith@gmail.com',
      password: ''
    },
    {
      id: 5,
      name: 'Jane',
      lastname: 'Smith',
      detail: 'Detail',
      email: 'jasmith@gmail.com',
      password: ''
    },
    {
      id: 6,
      name: 'Jane',
      lastname: 'Smith',
      detail: 'Detail',
      email: 'jasmith@gmail.com',
      password: ''
    }
  ];

  get agents() {
    return this._agents;
  }

  getAgentById(id: number): Agent | null {
    const result = this._agents.filter(agent => agent.id == id);

    if (result.length > 0) return result[0];
    return null;
  }

  saveAgent(agent: Agent): Agent {
    this._agents = [...this._agents, agent];
    return agent;
  }

  editAgent(id: number, agent: Agent): Agent | null {

    let edited: boolean = false;

    this._agents.filter(item => {
      if (item.id === id) {
        item.name = agent.name;
        item.lastname = agent.lastname;
        item.detail = agent.detail;
        edited = true;
      }
    });

    return edited? agent : null;
  }

  deleteAgent(id: number) {
    this._agents = this._agents.filter(agent => agent.id != id);
  }
}
